[![logo](https://www.hongsnet.net/images/logo.gif)](https://www.hongsnet.net)

# Docker 설치

설치는 RedHat과 Debian 계열을 다룬다.

## RedHat 계열

CentOS 7의 경우 Base Repository에 docker 패키지를 기본적으로 제공한다.

```bash
# yum install docker
...중략

# docker -v
Docker version 1.13.1, build 4ef4b30/1.13.1
```

> **참고** : CentOS 7 버전의 경우 기본적으로 설치되는 Docker 버전은 1.13.X 이다. 이 버전은 너무나 오래된 버전이며, 신규 기능에 대한 사용에 문제가 발생할 수 있다. 따라서 다음과 같이 별도의 rpm 파일을 이용해서 설치할 수 있다.

```bash
# mkdir docker20-10; cd docker20-10
# wget http://pds.hongsnet.net:8888/packages/docker/docker20-10.tar
# tar xvf docker20-10.tar
```

rpm 파일의 리스트는 다음과 같다.

```bash
# ls
container-selinux-2.107-3.el7.noarch.rpm            docker20-10.tar
containerd.io-1.4.3-3.1.el7.x86_64.rpm              fuse-overlayfs-0.7.2-6.el7_8.x86_64.rpm
docker-ce-20.10.2-3.el7.x86_64.rpm                  fuse3-libs-3.6.1-4.el7.x86_64.rpm
docker-ce-cli-20.10.2-3.el7.x86_64.rpm              slirp4netns-0.4.3-4.el7_8.x86_64.rpm
docker-ce-rootless-extras-20.10.2-3.el7.x86_64.rpm
```

다음과 같이 **yum 명령**을 이용해서 일괄설치를 진행한다.

```bash
# yum localinstall *.rpm
```

설치가 완료된 후 버전을 확인해보면 다음과 같이 더 최신의 패키지가 설치된 것을 볼 수 있다.

```bash
# docker -v
Docker version 20.10.2, build 2291f61
```

## Debian 계열

여기서는 Ubuntu

```bash
$ sudo apt-get update
$ sudo apt-get install docker.io
$ sudo ln -sf /usr/bin/docker.io /usr/local/bin/docker
```

> !참고 : Ubuntu에서는 docker.io 명령으로 설치되기 때문에 docker 명령으로 Link 하는 것이다.


## 공통

패키지 설치가 완료되었으면, 다음과 같이 docker 데몬을 시작하고, 활성화 한다.

```bash
# systemctl start docker; systemctl enable docker
```

